

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Time &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script src="../../../_static/js/bootstrap.min.js"></script>
        <script src="../../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="Calendar" href="calendar.html" />
    <link rel="prev" title="Getting started" href="../getting_started.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../concepts.html">Concepts</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../getting_started.html">Getting started</a><ul class="current">
<li class="toctree-l2 current"><a class="current reference internal" href="#">Time</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#create-a-time-object">Create a time object</a></li>
<li class="toctree-l3"><a class="reference internal" href="#using-a-time-object">Using a time object</a></li>
<li class="toctree-l3"><a class="reference internal" href="#containers">Containers</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#utcperiod">UtcPeriod</a></li>
<li class="toctree-l4"><a class="reference internal" href="#ymdhms">YMDhms</a></li>
<li class="toctree-l4"><a class="reference internal" href="#ywdhms">YWdhms</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="calendar.html">Calendar</a></li>
<li class="toctree-l2"><a class="reference internal" href="time_axis.html">TimeAxis</a></li>
<li class="toctree-l2"><a class="reference internal" href="time_series.html">TimeSeries</a></li>
<li class="toctree-l2"><a class="reference internal" href="dts.html">Distributed Time Series (DTS)</a></li>
<li class="toctree-l2"><a class="reference internal" href="notebooks.html">Examples</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../getting_started.html">Getting started</a> &raquo;</li>
        
      <li>Time</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../../_sources/content/time_series/getting_started/time.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="time">
<span id="usagetime"></span><h1>Time<a class="headerlink" href="#time" title="Permalink to this headline">¶</a></h1>
<p>As outlined in the chapter <a class="reference internal" href="../concepts/time.html#concepttime"><span class="std std-ref">Dealing with time</span></a>, only epoch time stamps are truly unique and native Python datetime
objects have difficulties when dealing with time zones.</p>
<p>Shyft uses for time representation the UTC epoch time stamp which is an a floating point value whose value expresses
seconds before the comma and microseconds after the comma in form of a <code class="docutils literal notranslate"><span class="pre">time</span></code> object. This section gives an
introduction to the type.</p>
<div class="section" id="create-a-time-object">
<h2>Create a time object<a class="headerlink" href="#create-a-time-object" title="Permalink to this headline">¶</a></h2>
<p>The creation of a <code class="docutils literal notranslate"><span class="pre">time</span></code> object is straightforward as the following code snippet demonstrates.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">time</span><span class="p">,</span> <span class="n">utctime_now</span>

<span class="c1"># The current timestamp in microsecond resolution is returned as follows.</span>
<span class="n">now</span> <span class="o">=</span> <span class="n">utctime_now</span><span class="p">()</span>                <span class="c1"># time(1584352047.236503)</span>

<span class="c1"># Create a time from a well defined iso8601 string.</span>
<span class="n">t0</span> <span class="o">=</span> <span class="n">time</span><span class="p">(</span><span class="s1">&#39;2018-10-15T16:30:15Z&#39;</span><span class="p">)</span>  <span class="c1"># time(1539621015)</span>

<span class="c1"># We can get the string back by using the built-int str</span>
<span class="n">t0_string</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">t0</span><span class="p">)</span>                <span class="c1"># &#39;2018-10-15T16:30:15Z&#39;   </span>

<span class="c1"># Create a time from an integer (Seconds) or a float (microseconds).</span>
<span class="n">t1</span> <span class="o">=</span> <span class="n">time</span><span class="p">(</span><span class="mi">3600</span><span class="p">)</span>                    <span class="c1"># time(3600)</span>

<span class="n">t2</span> <span class="o">=</span> <span class="n">time</span><span class="p">(</span><span class="mf">0.123456</span><span class="p">)</span>                <span class="c1"># time(0.123456)</span>

<span class="c1"># NOTE: Any information after microseconds gets rounded.</span>
<span class="n">t3</span> <span class="o">=</span> <span class="n">time</span><span class="p">(</span><span class="mf">0.1234568</span><span class="p">)</span>               <span class="c1"># time(0.123457)</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Note that Shyft only parses a subset of ISO8601 so many perfectly valid time strings produces errors, and it does not even parse every time string it produces itself. For example replacing the Z with a +01 will not work and will return a RuntimeError</p>
</div>
<p>There are three time constants that represent respectivly the least and largest time representable, and invalid time.
The minimum and maximum time constructs are mostly usefull as default values, and for creating time periods spanning “all” of time.
Invalid time may be returned by some functions to represent that whatever operation it were to do did not work,
and some Shyft constructs initialize to it by default.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">min_utctime</span><span class="p">,</span> <span class="n">max_utctime</span><span class="p">,</span> <span class="n">no_utctime</span> 
<span class="nb">print</span><span class="p">(</span><span class="n">min_utctime</span><span class="p">)</span>  <span class="c1"># time(-9223372036854.775391)</span>
<span class="nb">print</span><span class="p">(</span><span class="n">max_utctime</span><span class="p">)</span>  <span class="c1"># time(9223372036854.775391)</span>
<span class="nb">print</span><span class="p">(</span><span class="n">no_utctime</span><span class="p">)</span>   <span class="c1"># time(-9223372036854.775391)</span>
</pre></div>
</div>
</div>
<div class="section" id="using-a-time-object">
<h2>Using a time object<a class="headerlink" href="#using-a-time-object" title="Permalink to this headline">¶</a></h2>
<p>The time object is the basis for all time operations within Shyft. Its main usage for end users is in conjunction with a
<a class="reference internal" href="calendar.html#usagecalendar"><span class="std std-ref">Calendar</span></a> object as outlined in section <a class="reference internal" href="calendar.html#usagecalendartime"><span class="std std-ref">Calendar and time</span></a>. Nevertheless, basic arithmetic is possible.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">time</span><span class="p">,</span> <span class="n">deltahours</span><span class="p">,</span> <span class="n">deltaminutes</span>

<span class="c1"># Create a point in time</span>
<span class="n">t1</span> <span class="o">=</span> <span class="n">time</span><span class="p">(</span><span class="mi">3600</span><span class="p">)</span>  <span class="c1"># time(3600)</span>

<span class="c1"># Add two hours aka 7200 seconds</span>
<span class="n">t2</span> <span class="o">=</span> <span class="n">t1</span> <span class="o">+</span> <span class="n">deltahours</span><span class="p">(</span><span class="mi">2</span><span class="p">)</span>  <span class="c1"># time(10800)</span>

<span class="c1"># Subtract a minute aka 60 seconds</span>
<span class="n">t3</span> <span class="o">=</span> <span class="n">t1</span> <span class="o">-</span> <span class="n">deltaminutes</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>  <span class="c1"># time(3540)</span>

<span class="c1"># time can be added or subtracted directly</span>
<span class="n">t4</span> <span class="o">=</span> <span class="n">t1</span> <span class="o">+</span> <span class="n">time</span><span class="p">(</span><span class="mi">3600</span><span class="p">)</span>  <span class="c1"># time(7200)</span>

<span class="c1"># converting back</span>
<span class="n">my_int</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">t4</span><span class="p">)</span>    <span class="c1"># 7200</span>
<span class="n">my_dbl</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">t4</span><span class="p">)</span>  <span class="c1"># 7200.0</span>

<span class="c1"># time integrates fine with operators on different types</span>
<span class="n">is_equal1</span> <span class="o">=</span> <span class="p">(</span><span class="n">t4</span> <span class="o">==</span> <span class="mi">7200</span><span class="p">)</span>    <span class="c1"># True</span>
<span class="n">is_equal2</span> <span class="o">=</span> <span class="p">(</span><span class="n">t4</span> <span class="o">==</span> <span class="mf">7200.0</span><span class="p">)</span>  <span class="c1"># True</span>
<span class="n">unordered</span> <span class="o">=</span> <span class="p">[</span><span class="n">t4</span><span class="p">,</span> <span class="mi">7200</span><span class="p">,</span> <span class="mf">7199.9</span><span class="p">,</span> <span class="mi">7199</span><span class="p">,</span>  <span class="mf">7200.1</span><span class="p">]</span>
<span class="n">unordered</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>            <span class="c1"># [7199, 7199.9, time(7200), 7200, 7200.1]</span>
</pre></div>
</div>
</div>
<div class="section" id="containers">
<h2>Containers<a class="headerlink" href="#containers" title="Permalink to this headline">¶</a></h2>
<p>The following types help collating time information. These are used as data containers
and do by themselves not provide additional functionality. Often, these are method
return types.</p>
<div class="section" id="utcperiod">
<h3>UtcPeriod<a class="headerlink" href="#utcperiod" title="Permalink to this headline">¶</a></h3>
<p>An instance of the type <code class="docutils literal notranslate"><span class="pre">UtcPeriod</span></code> defines the half-open utc-time interval [<em>start</em>..*end*&gt; where
<em>end</em> is required to be equal or greater than <em>start</em>. Periods are building blocks of a
<a class="reference internal" href="time_axis.html#usagetimeaxis"><span class="std std-ref">TimeAxis</span></a>.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">UtcPeriod</span><span class="p">,</span> <span class="n">time</span>

<span class="c1"># ==== Creation</span>
<span class="c1"># create from integer epoch timestamps</span>
<span class="n">period1</span> <span class="o">=</span> <span class="n">UtcPeriod</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">2</span><span class="p">)</span>                  <span class="c1"># [1970-01-01T00:00:01Z,1970-01-01T00:00:02Z&gt;</span>
<span class="c1"># create from microseconds float epoch timestamps</span>
<span class="n">period2</span> <span class="o">=</span> <span class="n">UtcPeriod</span><span class="p">(</span><span class="mf">1.000001</span><span class="p">,</span> <span class="mf">2.000002</span><span class="p">)</span>    <span class="c1"># [1970-01-01T00:00:01.000001Z,1970-01-01T00:00:02.000002Z&gt;</span>
<span class="c1"># create from time objects</span>
<span class="n">period3</span> <span class="o">=</span> <span class="n">UtcPeriod</span><span class="p">(</span><span class="n">time</span><span class="p">(</span><span class="mi">4</span><span class="p">),</span> <span class="n">time</span><span class="p">(</span><span class="mi">5</span><span class="p">))</span>      <span class="c1"># [1970-01-01T00:00:04Z,1970-01-01T00:00:05Z&gt;</span>

<span class="c1"># WARNING: The constructor WILL accept invalid values!</span>
<span class="n">period4</span> <span class="o">=</span> <span class="n">UtcPeriod</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>    <span class="c1"># [not-valid-period&gt;</span>
<span class="n">period5</span> <span class="o">=</span> <span class="n">UtcPeriod</span><span class="p">()</span>        <span class="c1"># [not-valid-period&gt;</span>
<span class="c1"># the type exposes a method to check if start&lt;=end</span>
<span class="n">is_valid4</span> <span class="o">=</span> <span class="n">period4</span><span class="o">.</span><span class="n">valid</span><span class="p">()</span>  <span class="c1"># returns False</span>
<span class="n">is_valid5</span> <span class="o">=</span> <span class="n">period5</span><span class="o">.</span><span class="n">valid</span><span class="p">()</span>  <span class="c1"># returns False</span>

<span class="c1"># ==== contains</span>
<span class="c1"># Accepts int, float and time as input types</span>
<span class="n">is_contains</span> <span class="o">=</span> <span class="n">period1</span><span class="o">.</span><span class="n">contains</span><span class="p">(</span><span class="mf">1.000001</span><span class="p">)</span>   <span class="c1"># True</span>
<span class="n">is_not_contains</span> <span class="o">=</span> <span class="n">period1</span><span class="o">.</span><span class="n">contains</span><span class="p">(</span><span class="mi">3</span><span class="p">)</span>      <span class="c1"># False</span>

<span class="c1"># ==== overlaps</span>
<span class="n">is_overlap</span> <span class="o">=</span> <span class="n">UtcPeriod</span><span class="o">.</span><span class="n">overlaps</span><span class="p">(</span><span class="n">period1</span><span class="p">,</span> <span class="n">period2</span><span class="p">)</span>      <span class="c1"># True</span>
<span class="n">is_not_overlap</span> <span class="o">=</span> <span class="n">UtcPeriod</span><span class="o">.</span><span class="n">overlaps</span><span class="p">(</span><span class="n">period1</span><span class="p">,</span> <span class="n">period3</span><span class="p">)</span>  <span class="c1"># False</span>

<span class="c1"># ==== intersection</span>
<span class="c1"># Returns the intersection period between two periods</span>
<span class="n">intersection_valid</span> <span class="o">=</span> <span class="n">UtcPeriod</span><span class="o">.</span><span class="n">intersection</span><span class="p">(</span><span class="n">period1</span><span class="p">,</span> <span class="n">period2</span><span class="p">)</span>   <span class="c1"># [1970-01-01T00:00:01.000001Z,1970-01-01T00:00:02Z&gt;</span>
<span class="c1"># It returns an invalid empty period, if the periods do not overlap</span>
<span class="n">intersection_invalid</span> <span class="o">=</span> <span class="n">UtcPeriod</span><span class="o">.</span><span class="n">intersection</span><span class="p">(</span><span class="n">period1</span><span class="p">,</span> <span class="n">period3</span><span class="p">)</span> <span class="c1"># [not-valid-period&gt;</span>

<span class="c1"># ==== timespan </span>
<span class="n">delta_t</span> <span class="o">=</span> <span class="n">period1</span><span class="o">.</span><span class="n">timespan</span><span class="p">()</span>  <span class="c1"># time(1)</span>

<span class="c1"># ==== to_string</span>
<span class="n">period_string</span> <span class="o">=</span> <span class="n">period1</span><span class="o">.</span><span class="n">to_string</span><span class="p">()</span>  <span class="c1"># &#39;[1970-01-01T00:00:01Z,1970-01-01T00:00:02Z&gt;&#39;</span>

<span class="c1"># ==== start and end</span>
<span class="n">p1_start</span> <span class="o">=</span> <span class="n">period1</span><span class="o">.</span><span class="n">start</span>  <span class="c1"># time(1)</span>
<span class="n">p1_end</span> <span class="o">=</span> <span class="n">period1</span><span class="o">.</span><span class="n">end</span>      <span class="c1"># time(2)</span>
</pre></div>
</div>
</div>
<div class="section" id="ymdhms">
<h3>YMDhms<a class="headerlink" href="#ymdhms" title="Permalink to this headline">¶</a></h3>
<p>An instance of the type <code class="docutils literal notranslate"><span class="pre">YMDhms</span></code> defines the Calendar coordinates specifying Y, M, D, h, m, s and μs.
While this looks like a Python datetime, this type is specifically a container without any further
functionality. It is only used as return type and you can access the data via its properties.</p>
</div>
<div class="section" id="ywdhms">
<h3>YWdhms<a class="headerlink" href="#ywdhms" title="Permalink to this headline">¶</a></h3>
<p>An instance of the type <code class="docutils literal notranslate"><span class="pre">YWdhms</span></code> defines the Calendar coordinates y, iso-week number, iso-week day,
h, m, s and μs. It is only used as return type and you can access the data via its properties.</p>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="calendar.html" class="btn btn-neutral float-right" title="Calendar" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="../getting_started.html" class="btn btn-neutral float-left" title="Getting started" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>